public class Funktionen {

   // Seite 100
   public static int slowGGT(int x, int y){
       while(x != y){
           if(x > y)
              x = x-y;
           else
              y=y-x;
       }
       return x;
    }// end slowGGT
    
   // Seite 108 
   public static int fastGGT(int x, int y){
       while( x>0 && y>0 ){
           if(x>=y) x = x%y;
           else     y = y%x;
       }
       return x+y;
   }
   
   // Seite 134
   static int daysInYear(int jahr){
       int tage ;
       if( jahr%4 != 0) tage = 365;
       else if (jahr%100 != 0) tage = 366;
       else if (jahr%400 != 0) tage = 365;
       else tage = 366;
       return tage;
    }
    
    
    // Seite 136
    static void passWort(String benutzer, String passwort){
      int bl = benutzer.length();
      int pl = passwort.length();
      if(bl != pl){
        System.out.println("Falsches Passwort");
        return;
      }else{
        int i = 0;
        while(i < bl){
          if(benutzer.charAt(i) != passwort.charAt(pl-i-1)){
              System.out.println("Falsches Passwort");
              return;
          }else i++;
        }
        System.out.println("Willkommen Meister !");
      } 
    }// end of passWort
    
    // Seite 143
    static int tageImJahr(int jahr){
      if(jahr%4 == 0)
        if(jahr%100==0)
          if(jahr%400==0) return 366;
          else return 365;
        else return 366;
      else return 365;
    }
  
    // Seite 143
    static int tageJahr(int jahr){
      if(jahr%4 == 0 && jahr%100 != 0 || jahr%400 == 0) return 366;
      else return 365;
    }  
    
    static int monatsTage(int monat, int jahr){
      int tage;
      switch(monat){
        case 2: if(jahr%4 != 0 || jahr%400 != 0 && jahr%100 == 0 )tage = 28;
                else tage = 29; break;
        case 4: case 6: 
        case 9: case 11: tage = 30; break;
        default: tage = 31;
      }
      return tage;      
    }
    
    // Seite 147
    static void temperaturTabelle(){
      for (int i=0; i<100 ; i++){
        System.out.println(i + " C = " + (32+9*i/5) + " F");
        }
    }
    
    // Seite 148
    static void pythagoras(int n){
      for(int a=1; a <= n; a++){
        for(int b=1; b<=n ; b++){
          int aabb = a*a+b*b;
          int c = (int)Math.sqrt(aabb);
          if(aabb == c*c)
            System.out.print("("+a+","+b+","+c+")  ");
         }// Ende der inneren Schleife
       }// Ende der ueren Schleife
    }//end of pythagoras
    
}// Ende der Klasse Funktionen
