public class SparKonto extends Konto{

  // Auf Sparkonto knnen nur positive Betrge eingezahlt werden
  // einzahlen der Oberklasse wird berschrieben. 
  // intern wird aber das einzahlen der Oberklasse 
  // super.einzahlen(...)  verwendet

  void einzahlen(int betrag){
       if(betrag>0)
          super.einzahlen(betrag);
  }
  
  // Vom Sparkonto kann ich auf ein anderes Konto 
  // berweisen, ich darf das Sparkonto aber nicht berziehen

  void berweisen(Konto empfnger, int betrag){
    if(betrag > 0 && betrag > getSaldo()){
      super.einzahlen(-betrag);
      empfnger.einzahlen(betrag);
    }  
  }

}
